//
//  CNC_KontrollerAppDelegate.m
//  CNC_Kontroller
//
//  Created by Johan Larsby on 8/9/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "CNC_KontrollerAppDelegate.h"

#include <stdio.h>    /* Standard input/output definitions */
#include <stdint.h>   /* Standard types */
#include <string.h>   /* String function definitions */
#include <unistd.h>   /* UNIX standard function definitions */
#include <fcntl.h>    /* File control definitions */
#include <errno.h>    /* Error number definitions */
#include <termios.h>  /* POSIX terminal control definitions */
#include <sys/ioctl.h>
#include <getopt.h>
#include <sys/ioctl.h>
#include "stdio.h"


//#include <iostream>

#include <stdint.h>   /* Standard types */

#include <assert.h>
#include <pthread.h>

@implementation CNC_KontrollerAppDelegate

@synthesize window;

@synthesize tf_Code;
@synthesize tf_Log;
//@synthesize isWaiting;


int serialport_init(const char* serialport, int baud);
int serialport_writebyte(int fd, uint8_t b);
int serialport_write(int fd, const char* str);
int serialport_read_until(int fd, char* buf, char until);

int n;
char c;
bool is_running=true;
int fd = 0;
int baudrate = B19200;  // default
char buf[256];
int rc;
int tem;

bool isWaitingCowabunga=false;



int serialport_writebyte( int fd, uint8_t b)
{
    int n = write(fd,&b,1);
    if( n!=1)
        return -1;
    return 0;
}

int serialport_write(int fd, const char* str)
{
    int len = strlen(str);
    int n = write(fd, str, len);
    if( n!=len ) 
        return -1;
    return 0;
}

int serialport_read_until(int fd, char* buf, char until)
{
    char b[1];
    int i=0;
    do { 
        int n = read(fd, b, 1);  // read a char at a time
        if( n==-1) return -1;    // couldn't read
        if( n==0 ) {
            usleep( 10 * 1000 ); // wait 10 msec try again
            continue;
        }
        buf[i] = b[0]; i++;
    } while( b[0] != until );
	
    buf[i] = 0;  // null terminate the string
    return 0;
}

// takes the string name of the serial port (e.g. "/dev/tty.usbserial","COM1")
// and a baud rate (bps) and connects to that port at that speed and 8N1.
// opens the port in fully raw mode so you can send binary data.
// returns valid fd, or -1 on error
int serialport_init(const char* serialport, int baud)
{
    struct termios toptions;
    int fd;
    
    //fprintf(stderr,"init_serialport: opening port %s @ %d bps\n",
    //        serialport,baud);
	
    fd = open(serialport, O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd == -1)  {
        printf("init_serialport: Unable to open port ");
        return -1;
    }
    
    if (tcgetattr(fd, &toptions) < 0) {
        printf("init_serialport: Couldn't get term attributes");
        return -1;
    }
    speed_t brate = baud; // let you override switch below if needed
    switch(baud) {
		case 4800:   brate=B4800;   break;
		case 9600:   brate=B9600;   break;
#ifdef B14400
		case 14400:  brate=B14400;  break;
#endif
		case 19200:  brate=B19200;  break;
#ifdef B28800
		case 28800:  brate=B28800;  break;
#endif
		case 38400:  brate=B38400;  break;
		case 57600:  brate=B57600;  break;
		case 115200: brate=B115200; break;
    }
    cfsetispeed(&toptions, brate);
    cfsetospeed(&toptions, brate);
	
    // 8N1
    toptions.c_cflag &= ~PARENB;
    toptions.c_cflag &= ~CSTOPB;
    toptions.c_cflag &= ~CSIZE;
    toptions.c_cflag |= CS8;
    // no flow control
    toptions.c_cflag &= ~CRTSCTS;
	
    toptions.c_cflag |= CREAD | CLOCAL;  // turn on READ & ignore ctrl lines
    toptions.c_iflag &= ~(IXON | IXOFF | IXANY); // turn off s/w flow ctrl
	
    toptions.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG); // make raw
    toptions.c_oflag &= ~OPOST; // make raw
	
    // see: http://unixwiz.net/techtips/termios-vmin-vtime.html
    toptions.c_cc[VMIN]  = 0;
    toptions.c_cc[VTIME] = 20;
    
    if( tcsetattr(fd, TCSANOW, &toptions) < 0) {
        printf("init_serialport: Couldn't set term attributes");
        return -1;
    }
	
    return fd;
}

 
- (void)logOut:(NSString*) instring
{
	NSRange range;
    range = NSMakeRange ([[tf_Log string] length], 0);
	
    [tf_Log replaceCharactersInRange: range withString: instring];
	range = NSMakeRange ([[tf_Log string] length], 0);
	
    [tf_Log scrollRangeToVisible: range];
	
}


- (void)addCommandToQue:(NSString*) inCommand
{
	NSString *noWhite = [inCommand stringByReplacingOccurrencesOfString:@" " withString:@""];
	NSString *allCaps = [noWhite uppercaseString];
	[codesToSend addObject: allCaps];
}





- (void) handleTimer: (NSTimer *) timer
{
	
		 	[self processQue];
			timer = [NSTimer scheduledTimerWithTimeInterval: 0.1
													 target: self
												   selector: @selector(handleTimer:)
												   userInfo: nil
													repeats: NO];
	 
}

- (void)processQue
{
	
	if (codesToSend.count==0) {
		return;
	}
	isWaitingCowabunga = 1;
	NSString *stringRep = [NSString stringWithFormat:@"%@",[codesToSend objectAtIndex:0]];

	sprintf(buf,"%s\n",	[stringRep cString]); 

	rc = serialport_write(fd, buf);
	
	[codesToSend removeObjectAtIndex:0];
	[self logOut:[NSString stringWithCString:buf]  ];
	
	if(rc==-1)	 {	
		[self logOut:@"ERROR\n"];
	}
	else {
		serialport_read_until(fd, buf, '\n');
		[self logOut:[NSString stringWithCString:buf]  ];
		
	}
	isWaitingCowabunga=0;

}
 


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	// Insert code here to initialize your application 
	
	[self Connect:NULL ];
	codesToSend =[[NSMutableArray alloc] init];

		
	
	if(fd!=-1) 
	{
		tem = fcntl(0, F_GETFL, 0);
		fcntl (0, F_SETFL, (tem | O_NDELAY));
		
	 
	}
	
	duration = .1;
	
	NSTimer *timer;
	
	timer = [NSTimer scheduledTimerWithTimeInterval: 0.1
											 target: self
										   selector: @selector(handleTimer:)
										   userInfo: nil
											repeats: NO];
	
	
/*

 
 serialport_write(fd,"600"); //Clear all leds
 */
}
 

- (IBAction)Xp:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"X10"];
}
- (IBAction)Xn:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"X-10"];
}

- (IBAction)Yp:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Y10"];
}
- (IBAction)Yn:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Y-10"];
}

- (IBAction)Zp:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Z10"];
}
- (IBAction)Zn:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Z-10"];
	
}

- (IBAction)SetHome:(id)sender
{ 
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"G92"];
	
}

- (IBAction)GoHome:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"G28"];
}


- (IBAction)xp:(id)sender;
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"X1"];
	
}
- (IBAction)xn:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"X-1"];
	
}

- (IBAction)yp:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Y1"];
	
}
- (IBAction)yn:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Y-1"];
	
}

- (IBAction)zp:(id)sender
{ 
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Z1"];
	
}
- (IBAction)zn:(id)sender
{
	[self addCommandToQue:@"G21"];
	[self addCommandToQue:@"G91"];
	[self addCommandToQue:@"Z-1"];
	
}



- (IBAction)Start:(id)sender
{
	NSString *programString;
	programString = [[tf_Code  textStorage] string];
	 NSArray *chunks = [programString componentsSeparatedByString: @"\n"];
	for(int i=0;i<chunks.count;i++)
	{
		NSString *stringRep = [NSString stringWithFormat:@"%@",[chunks objectAtIndex:i]];
		[self addCommandToQue:stringRep];
	
	}

}
- (IBAction)Stop:(id)sender
{
	[self logOut:@"trying to stop\n"];
	[codesToSend removeAllObjects];
}

- (IBAction)Connect:(id)sender;
{
	
	[self logOut:@"starting stuff\n"];
	isWaitingCowabunga = false;
	
	char buf[256];
	fd = serialport_init("/dev/tty.usbserial-A800834f", baudrate);
	
	if (fd!=-1) {
		[self logOut:@"Setup worked\n"];
	}
	else {
		[self logOut:@"Did not connect\n"];
	}
	
	
    [self logOut:@"Waiting\n"];
	serialport_read_until(fd, buf, '\n');
	printf("read: %s\n",buf);
	

}
- (IBAction)Disconnect:(id)sender;
{
 fcntl(0, F_SETFL, tem);
}


 @end
